"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "GoSell", {
  enumerable: true,
  get: function get() {
    return _GoSell["default"];
  }
});
Object.defineProperty(exports, "GoSellElements", {
  enumerable: true,
  get: function get() {
    return _GoSellElements["default"];
  }
});
exports.submit = exports.showResult = exports.openPaymentPage = exports.openLightBox = exports.goSellElements = exports.config = void 0;

require("@babel/polyfill/noConflict");

var _react = _interopRequireDefault(require("react"));

var _queryString = require("query-string");

var _reactDom = _interopRequireDefault(require("react-dom"));

var _GoSell = _interopRequireDefault(require("./elements/GoSell.js"));

var _GoSellElements = _interopRequireDefault(require("./elements/GoSellElements.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var config = function config(object) {
  var elementExists = document.getElementById("gosell-js-lib");

  if (!object.containerID && elementExists) {
    object.containerID = "gosell-js-lib";
  } else if (!elementExists && object.containerID == null && document.getElementById("gosell-gateway") == null) {
    var container = document.createElement("div");
    container.setAttribute("id", "gosell-js-lib");
    document.body.insertBefore(container, document.body.childNodes[0]);
    object.containerID = "gosell-js-lib";
  }

  _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_GoSell["default"], null), document.getElementById(object.containerID));

  _GoSell["default"].config(object);
};

exports.config = config;

var openLightBox = function openLightBox() {
  _GoSell["default"].openLightBox();
};

exports.openLightBox = openLightBox;

var openPaymentPage = function openPaymentPage() {
  //this option only for charge & authorize cases
  //The function calls create charge or Authorize API
  _GoSell["default"].openPaymentPage();
};

exports.openPaymentPage = openPaymentPage;

var showResult = function showResult(object) {
  var urlParams = (0, _queryString.parse)(window.location.search);

  if (urlParams.tap_id) {
    if (document.getElementById("gosell-gateway") == null) {
      var container = document.createElement("div");
      container.setAttribute("id", "gosell-js-lib");
      document.body.insertBefore(container, document.body.childNodes[0]);

      if (object && object.callback) {
        _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_GoSell["default"], {
          callback: object.callback
        }), document.getElementById("gosell-js-lib"));
      } else {
        _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_GoSell["default"], null), document.getElementById("gosell-js-lib"));
      }
    }
  }
};

exports.showResult = showResult;

var goSellElements = function goSellElements(object) {
  _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_GoSellElements["default"], {
    gateway: object.gateway,
    transaction: {
      mode: "token"
    }
  }), document.getElementById(object.containerID));
};

exports.goSellElements = goSellElements;

var submit = function submit() {
  _GoSellElements["default"].submit();
}; // for NPM


exports.submit = submit;
// for browser
window.goSell = {
  config: config,
  GoSell: _GoSell["default"],
  GoSellElements: _GoSellElements["default"],
  openLightBox: openLightBox,
  openPaymentPage: openPaymentPage,
  showResult: showResult,
  goSellElements: goSellElements,
  submit: submit
};